diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index b347c3cf2..13fda2270 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -41,23 +41,18 @@ import net.minecraft.core.world.chunk.ChunkCache;
 import net.minecraft.core.world.chunk.ChunkCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.ChunkSection;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.lighting.LightingEngine;
 import net.minecraft.core.world.lighting.LightingEngineLegacy;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
-import net.minecraft.core.world.pos.ChunkPos;
-import net.minecraft.core.world.pos.ChunkTilePos;
-import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.pos.*;
 import net.minecraft.core.world.save.*;
 import net.minecraft.core.world.saveddata.SavedData;
-import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.type.WorldType;
-import net.minecraft.core.world.type.WorldTypeGroups;
 import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
@@ -84,8 +79,8 @@ import static net.minecraft.core.Global.DAY_LENGTH_TICKS;
 import static net.minecraft.core.Global.accessor;
 import static net.minecraft.core.Global.isServer;
 
-public class World implements MutableWorldSource {
-    private static final Logger LOGGER = LogUtils.getLogger();
+public abstract class World implements MutableWorldSource {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
     public static boolean AUTOSAVE = true;
 
     public static final int HEIGHT_BLOCKS = 256;
@@ -108,7 +103,7 @@ public class World implements MutableWorldSource {
     public final @NotNull List<@NotNull Entity> weatherEffects = new ObjectArrayList<>();
     public final @NotNull List<@NotNull AABBdc> collidingBoundingBoxes = new ObjectArrayList<>();
     public final @NotNull List<@NotNull LevelListener> listeners = new ObjectArrayList<>();
-    private final @NotNull Set<@NotNull ChunkCoordinate> positionsToUpdate = new ObjectOpenHashSet<>();
+    private final @NotNull Set<@NotNull ChunkPosc> positionsToUpdate = new ObjectOpenHashSet<>();
     private final @NotNull List<@NotNull Entity> entityBuffer = new ObjectArrayList<>();
     private final @NotNull Set<@NotNull NextTickListEntry> immediatelyUpdatedPositions = new ObjectOpenHashSet<>();
 
@@ -120,19 +115,17 @@ public class World implements MutableWorldSource {
     public int startingRainbowTicks = 0;
     public boolean dayCanHaveRainbow = true;
     public boolean noNeighborUpdate = false;
-    private long lockTimestamp = System.currentTimeMillis();
+
     public final @NotNull Random rand = new Random();
     public final boolean isNewWorld;
-    public Dimension dimension;
-    public WorldType worldType;
-    public IChunkProvider chunkProvider;
+    public final @NotNull Dimension dimension;
+    public final @NotNull ChunkProvider chunkProvider;
     private final @NotNull LevelStorage levelStorage;
     private final @NotNull LevelData levelData;
     private final @NotNull DimensionData dimensionData;
     public boolean findingSpawnPoint;
     protected boolean enoughPlayersSleeping;
-    public final @NotNull SavedDataStorage savedDataStorage;
-    protected final LightingEngine lightingEngine = new LightingEngineLegacy(this);
+    protected final @NotNull LightingEngine lightingEngine = new LightingEngineLegacy(this);
     private boolean updatingTileEntities;
 
     private int caveSoundCounter = this.rand.nextInt(12000);
@@ -141,35 +134,37 @@ public class World implements MutableWorldSource {
     private long runtime = 0;
     public int dayCountLastTick;
 
-    public BiomeProvider biomeProvider;
-    public SeasonManager seasonManager;
+    public final @NotNull BiomeProvider biomeProvider;
+    public final @NotNull SeasonManager seasonManager;
     public WeatherManager weatherManager;
 
     private final @NotNull CommandManager commandManager = new CommandManager(isServer);
     private final @NotNull WireHandler wireHandler = new WireHandler(this);
 
-    //Usually called when a world is loaded or generated (Singleplayer & Server)
-    public World(
-        final @NotNull LevelStorage levelStorage,
-        final @Nullable String name,
+    private World(
         final long seed,
+        final @Nullable String name,
         final @NotNull Dimension dimension,
+        final @NotNull LevelStorage levelStorage,
+        final @Nullable LevelData levelData,
+        final @Nullable DimensionData dimensionData,
         final @Nullable Biome startingBiome
     ) {
+        if (name == null && levelData == null) {
+            throw new IllegalArgumentException("name and levelData cannot both be null!");
+        }
+
         this.levelStorage = levelStorage;
-        this.savedDataStorage = new SavedDataStorage(levelStorage);
 
-        final @Nullable LevelData levelData = levelStorage.getLevelData();
+        // Set up level data
         this.isNewWorld = levelData == null;
-        this.levelData = Objects.requireNonNullElseGet(levelData, () -> new LevelData(seed, name));
+        this.levelData = Objects.requireNonNullElseGet(levelData, () -> new LevelData(seed, Objects.requireNonNull(name)));
 
-        // Provided dimension
+        // Set up dimension data
         this.dimension = dimension;
-        this.dimensionData = Objects.requireNonNullElseGet(levelStorage.getDimensionData(this.dimension.id), () -> new DimensionData(this.dimension.defaultWorldType));
-
-        // World type from dimension data
-        this.worldType = this.dimensionData.getWorldType();
+        this.dimensionData = Objects.requireNonNullElseGet(dimensionData, () -> new DimensionData(this.dimension.defaultWorldType));
 
+        // Set up weather manager
         this.weatherManager = new WeatherManager(this,
             this.dimensionData.getCurrentWeather(),
             this.dimensionData.getNextWeather(),
@@ -177,97 +172,64 @@ public class World implements MutableWorldSource {
             this.dimensionData.getWeatherPower()
         );
 
-        this.chunkProvider = createChunkProvider();
+        // Set up chunk provider
+        this.chunkProvider = this.createChunkProvider(levelStorage);
 
-        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
+        // Set up season manager
+        this.seasonManager = SeasonManager.fromConfig(this, this.getWorldType().getSeasonConfig());
 
-        this.biomeProvider = this.worldType.createBiomeProvider(this);
-
-        if (this.isNewWorld) {
-            this.worldType.onWorldCreation(this);
-            getInitialSpawnLocation(startingBiome);
-        }
-        updateSkyBrightness();
+        // Set up biome provider
+        this.biomeProvider = this.getWorldType().createBiomeProvider(this);
 
+        // Set up command manager
         this.commandManager.init();
-    }
-
-    //Usually called when going through portals
-    public World(final @NotNull World parent, final @NotNull Dimension dimension) {
-        this.lockTimestamp = parent.lockTimestamp;
-        this.levelStorage = parent.levelStorage;
-        this.dimension = dimension;
 
-        this.levelData = new LevelData(parent.levelData);
-        this.dimensionData = Objects.requireNonNullElseGet(parent.levelStorage.getDimensionData(this.dimension.id), () -> new DimensionData(this.dimension.defaultWorldType));
-
-        this.weatherManager = new WeatherManager(this,
-            this.dimensionData.getCurrentWeather(),
-            this.dimensionData.getNextWeather(),
-            this.dimensionData.getWeatherDuration(),
-            this.dimensionData.getWeatherPower()
-        );
-
-        this.isNewWorld = false;
-
-        // Set up info from dimension data
-        this.worldType = this.dimensionData.getWorldType();
-
-        this.savedDataStorage = new SavedDataStorage(this.levelStorage);
-        this.chunkProvider = createChunkProvider();
-        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
-
-        this.biomeProvider = this.worldType.createBiomeProvider(this);
-
-        updateSkyBrightness();
-
-        this.commandManager.init();
+        // Do world initialization
+        if (this.isNewWorld && !this.isClientSide) {
+            this.getWorldType().onWorldCreation(this);
+            this.getInitialSpawnLocation(startingBiome);
+        }
+        this.updateSkyBrightness();
     }
 
-    //Usually called when joining a server
+    // Usually called when a world is loaded or generated (Singleplayer & Server)
     public World(
-        final @NotNull SavedDataStorage savedDataStorage,
-        final @NotNull String name,
+        final @NotNull LevelStorage levelStorage,
+        final @Nullable String name,
         final long seed,
         final @NotNull Dimension dimension,
-        final @NotNull WorldType worldType
+        final @Nullable Biome startingBiome
     ) {
-        this.levelStorage = savedDataStorage.getLevelStorage();
-        this.savedDataStorage = savedDataStorage;
-
-        this.levelData = new LevelData(seed, name);
-        this.isNewWorld = false;
-
-        // Provided dimension
-        this.dimension = dimension;
-        this.dimensionData = new DimensionData(worldType);
-
-        // Provided world type
-        this.worldType = worldType;
-
-        this.weatherManager = new WeatherManager(this);
-
-        this.chunkProvider = createChunkProvider();
-
-        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
-
-        this.biomeProvider = this.worldType.createBiomeProvider(this);
-
-        this.updateSkyBrightness();
-
-        this.commandManager.init();
+        this(
+            seed,
+            name,
+            dimension,
+            levelStorage,
+            levelStorage.getLevelData(),
+            levelStorage.getDimensionData(dimension),
+            startingBiome
+        );
     }
 
-    public World() {
-        this.levelStorage = new LevelStorageDummy();
-        this.savedDataStorage = new SavedDataStorage(this.levelStorage);
-
-        this.isNewWorld = false;
-        this.levelData = new LevelData(0, "Dummy World");
-        this.dimensionData = new DimensionData(WorldTypeGroups.DEFAULT.get(Dimension.OVERWORLD));
+    // Usually called when going through portals
+    public World(
+        final @NotNull World parent,
+        final @NotNull Dimension dimension
+    ) {
+        this(
+            parent.getLevelData().getRandomSeed(),
+            parent.getLevelData().getWorldName(),
+            dimension,
+            parent.levelStorage,
+            new LevelData(parent.levelData),
+            parent.levelStorage.getDimensionData(dimension),
+            null
+        );
     }
 
-    public <T> T getGameRuleValue(GameRule<T> gameRule) {
+    public abstract void setLightningFlicker(final int flicker);
+
+    public <T> T getGameRuleValue(final GameRule<T> gameRule) {
         return this.levelData.getGameRules().getValue(gameRule);
     }
 
@@ -292,47 +254,47 @@ public class World implements MutableWorldSource {
         return this.wireHandler;
     }
 
-    protected IChunkProvider createChunkProvider() {
-        IChunkLoader chunkLoader = this.levelStorage.getChunkLoader(this.dimension);
+    protected abstract @NotNull ChunkProvider createChunkProvider(@NotNull LevelStorage levelStorage); /* {
+        final ChunkLoader chunkLoader = this.levelStorage.getChunkLoader(this.dimension);
         return accessor.createChunkProvider(this, chunkLoader);
-    }
+    }*/
 
-    protected void getInitialSpawnLocation(@Nullable Biome startingBiome) {
+    protected void getInitialSpawnLocation(@Nullable final Biome startingBiome) {
         this.findingSpawnPoint = true;
-        getWorldType().getInitialSpawnLocation(this, startingBiome);
+        this.getWorldType().getInitialSpawnLocation(this, startingBiome);
         this.findingSpawnPoint = false;
     }
 
     public void getRespawnLocation() {
-        getWorldType().getRespawnLocation(this);
+        this.getWorldType().getRespawnLocation(this);
     }
 
-    public int getTopBlock(int x, int z) {
-        int y = this.levelData.getSpawnY() - 1;
-        while (!isAirBlock(x, y + 1, z)) {
+    public int getTopBlock(final int x, final int z) {
+        int y = this.levelData.getSpawnPos().y() - 1;
+        while (!this.isAirBlock(x, y + 1, z)) {
             y++;
         }
-        return getBlockId(x, y, z);
+        return this.getBlockId(x, y, z);
     }
 
-    public void spawnPlayerWithLoadedChunks(Player player, boolean respawning) {
+    public void spawnPlayerWithLoadedChunks(final Player player, final boolean respawning) {
         try {
             if (!respawning) {
-                PlayerIO playerIO = this.levelStorage.getPlayerFileData();
+                final PlayerIO playerIO = this.levelStorage.getPlayerFileData();
                 if (playerIO != null) {
                     playerIO.load(player);
                 }
             }
-            int chunkX = MathHelper.floor_float((int) player.x) / Chunk.CHUNK_SIZE_X;
-            int chunkZ = MathHelper.floor_float((int) player.z) / Chunk.CHUNK_SIZE_Z;
+            final int chunkX = MathHelper.floor_float((int) player.x) / Chunk.CHUNK_SIZE_X;
+            final int chunkZ = MathHelper.floor_float((int) player.z) / Chunk.CHUNK_SIZE_Z;
             this.chunkProvider.setCurrentChunkOver(chunkX, chunkZ);
-            entityJoinedWorld(player);
-        } catch (Exception e) {
+            this.entityJoinedWorld(player);
+        } catch (final Exception e) {
             LOGGER.error("Failed to spawn player with loaded chunks!", e);
         }
     }
 
-    public void saveWorld(boolean saveImmediately, ProgressListener progressUpdate, boolean saveLevelData) {
+    public void saveWorld(final boolean saveImmediately, final ProgressListener progressUpdate, final boolean saveLevelData) {
         if (!this.chunkProvider.canSave()) {
             return;
         }
@@ -342,7 +304,7 @@ public class World implements MutableWorldSource {
                 progressUpdate.progressStart("Saving level data");
             }
 
-            saveWorldData();
+            this.saveWorldData();
         }
 
         if (progressUpdate != null) {
@@ -356,18 +318,17 @@ public class World implements MutableWorldSource {
     }
 
     private void saveWorldData() {
-        checkSessionLock();
+        this.checkSessionLock();
         this.levelStorage.saveLevelDataAndPlayerData(this.levelData, this.players);
         this.levelStorage.saveDimensionData(this.dimension.id, this.dimensionData);
-        this.savedDataStorage.save();
     }
 
-    public boolean pauseScreenSave(int i) {
+    public boolean pauseScreenSave(final int i) {
         if (!this.chunkProvider.canSave()) {
             return true;
         }
         if (i == 0) {
-            saveWorldData();
+            this.saveWorldData();
         }
         return this.chunkProvider.saveChunks(false, null);
     }
@@ -401,7 +362,7 @@ public class World implements MutableWorldSource {
             }
 
             if (temperature == Double.NEGATIVE_INFINITY) {
-                temperature = getBiomeProvider().getTemperature(tilePos.x(), tilePos.z());
+                temperature = this.getBiomeProvider().getTemperature(tilePos.x(), tilePos.z());
                 if (chunk != null) {
                     chunk.setBlockTemperature(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), temperature);
                 }
@@ -534,6 +495,7 @@ public class World implements MutableWorldSource {
     public boolean areBlocksLoaded(final @NotNull AABBdc aabb) {
         return this.areBlocksLoaded(new TilePos(aabb.minX(), aabb.minY(), aabb.minZ()), new TilePos(aabb.maxX(), aabb.maxY(), aabb.maxZ()));
     }
+
     public boolean areBlocksLoaded(final @NotNull TilePosc tilePos, final int range) {
         return this.areBlocksLoaded(tilePos.sub(range, range, range, new TilePos()), tilePos.add(range, range, range, new TilePos()));
     }
@@ -572,7 +534,7 @@ public class World implements MutableWorldSource {
         return this.areBlocksLoaded(new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    public boolean isChunkLoaded(final @NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(final @NotNull ChunkPosc chunkPos) {
         return this.chunkProvider.isChunkLoaded(chunkPos);
     }
 
@@ -590,11 +552,11 @@ public class World implements MutableWorldSource {
         return this.getChunk(new TilePos(x, 0, z));
     }
 
-    public @NotNull Chunk getChunk(final @NotNull ChunkPos chunkPos) {
+    public @NotNull Chunk getChunk(final @NotNull ChunkPosc chunkPos) {
         return this.chunkProvider.provideChunk(chunkPos, true);
     }
 
-    public @NotNull Chunk getChunk(final @NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk getChunk(final @NotNull ChunkPosc chunkPos, final boolean priority) {
         return this.chunkProvider.provideChunk(chunkPos, priority);
     }
 
@@ -769,7 +731,7 @@ public class World implements MutableWorldSource {
     }
 
     public void notifyBlocksOfNeighborChange(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        TilePos queryPos = new TilePos();
+        final TilePos queryPos = new TilePos();
         this.notifyBlockOfNeighborChange(tilePos.add(Direction.WEST, queryPos), block);
         this.notifyBlockOfNeighborChange(tilePos.add(Direction.EAST, queryPos), block);
         this.notifyBlockOfNeighborChange(tilePos.add(Direction.DOWN, queryPos), block);
@@ -829,7 +791,7 @@ public class World implements MutableWorldSource {
 
         if (first) {
             if (this.getBlockLitInteriorSurface(tilePos)) {
-                TilePos queryPos = new TilePos();
+                final TilePos queryPos = new TilePos();
                 final int lightUp = this.getBlockLightValue_do(tilePos.add(Direction.UP, queryPos), false);
                 final int lightEast = this.getBlockLightValue_do(tilePos.add(Direction.EAST, queryPos), false);
                 final int lightWest = this.getBlockLightValue_do(tilePos.add(Direction.WEST, queryPos), false);
@@ -887,7 +849,7 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public byte getSavedLightIndex(@NotNull TilePosc tilePos) {
+    public byte getSavedLightIndex(@NotNull final TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return LightLayer.DEFAULT_LIGHT_INDEX;
         } else if (!this.isBlockLoaded(tilePos)) {
@@ -899,7 +861,7 @@ public class World implements MutableWorldSource {
 
     @Override
     public boolean isRetro() {
-        return this.worldType.isRetro();
+        return this.getWorldType().isRetro();
     }
 
     @Override
@@ -915,22 +877,22 @@ public class World implements MutableWorldSource {
     @Override
     public float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission) {
         final int lightValue = this.getBlockLightValue(tilePos);
-        return this.worldType.getBrightnessRamp()[Math.max(lightValue, lightEmission)];
+        return this.getWorldType().getBrightnessRamp()[Math.max(lightValue, lightEmission)];
     }
 
     @Override
     public byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission) {
-        byte lightIndex = getSavedLightIndex(tilePos);
+        byte lightIndex = this.getSavedLightIndex(tilePos);
         lightIndex = LightIndexHelper.max(lightIndex, (byte) lightEmission);
 
         if (this.getBlockLitInteriorSurface(tilePos)) {
-            TilePos queryPos = new TilePos();
-            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.up(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.down(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.east(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.west(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.south(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.north(queryPos)));
+            final TilePos queryPos = new TilePos();
+            lightIndex = LightIndexHelper.max(lightIndex, this.getSavedLightIndex(tilePos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.getSavedLightIndex(tilePos.down(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.getSavedLightIndex(tilePos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.getSavedLightIndex(tilePos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.getSavedLightIndex(tilePos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.getSavedLightIndex(tilePos.north(queryPos)));
         }
 
         return lightIndex;
@@ -938,35 +900,35 @@ public class World implements MutableWorldSource {
 
     @Override
     public float getLightBrightness(final @NotNull TilePosc tilePos) {
-        return this.worldType.getBrightnessRamp()[this.getBlockLightValue(tilePos)];
+        return this.getWorldType().getBrightnessRamp()[this.getBlockLightValue(tilePos)];
     }
 
     public boolean isDaytime() {
         return this.skyDarken < 4;
     }
 
-    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull Vector3dc start, @NotNull Vector3dc end) {
-        return checkBlockCollisionBetweenPoints(start, end, false, false, false);
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull final Vector3dc start, @NotNull final Vector3dc end) {
+        return this.checkBlockCollisionBetweenPoints(start, end, false, false, false);
     }
 
 
-    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull Vector3dc start, @NotNull Vector3dc end, boolean shouldCollideWithFluids) {
-        return checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false, false);
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull final Vector3dc start, @NotNull final Vector3dc end, final boolean shouldCollideWithFluids) {
+        return this.checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false, false);
     }
 
-    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull Vector3dc start, @NotNull Vector3dc end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes) {
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull final Vector3dc start, @NotNull final Vector3dc end, final boolean shouldCollideWithFluids, final boolean ignoreNonColliderBlocks, final boolean useSelectorBoxes) {
         if (!start.isFinite()) {
             return null;
         }
         if (!end.isFinite()) {
             return null;
         }
-        Vector3d start2 = new Vector3d(start);
-        Vector3d end2 = new Vector3d(end);
-        TilePos blockEnd = new TilePos(end2);
-        TilePos blockStart = new TilePos(start2);
-        final @NotNull Block<?> block = getBlockType(blockStart);
-        int meta = getBlockData(blockStart);
+        final Vector3d start2 = new Vector3d(start);
+        final Vector3d end2 = new Vector3d(end);
+        final TilePos blockEnd = new TilePos(end2);
+        final TilePos blockStart = new TilePos(start2);
+        final @NotNull Block<?> block = this.getBlockType(blockStart);
+        final int meta = this.getBlockData(blockStart);
         final @Nullable AABBdc aabb;
         if (useSelectorBoxes) {
             aabb = block.getSelectionAABB(this, blockStart);
@@ -974,7 +936,7 @@ public class World implements MutableWorldSource {
             aabb = block.getCollisionAABB(this, blockStart);
         }
         if ((!ignoreNonColliderBlocks || aabb != null) && block.canCollideCheck(meta, shouldCollideWithFluids)) {
-            HitResult hitResult = block.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
+            final HitResult hitResult = block.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
             if (hitResult != null) {
                 return hitResult;
             }
@@ -1016,9 +978,9 @@ public class World implements MutableWorldSource {
             double d3 = 999D;
             double d4 = 999D;
             double d5 = 999D;
-            double d6 = end2.x - start2.x;
-            double d7 = end2.y - start2.y;
-            double d8 = end2.z - start2.z;
+            final double d6 = end2.x - start2.x;
+            final double d7 = end2.y - start2.y;
+            final double d8 = end2.z - start2.z;
             if (flag2) {
                 d3 = (d - start2.x) / d6;
             }
@@ -1057,7 +1019,7 @@ public class World implements MutableWorldSource {
                 start2.y += d7 * d5;
                 start2.z = d2;
             }
-            Vector3d startCopy = new Vector3d(start2);
+            final Vector3d startCopy = new Vector3d(start2);
             blockStart.x = (int) (startCopy.x = MathHelper.floor(start2.x()));
             if (byte0 == 5) {
                 blockStart.x--;
@@ -1073,16 +1035,16 @@ public class World implements MutableWorldSource {
                 blockStart.z--;
                 startCopy.z++;
             }
-            final @NotNull Block<?> block1 = getBlockType(blockStart);
+            final @NotNull Block<?> block1 = this.getBlockType(blockStart);
             final @Nullable AABBdc aabb1;
             if (useSelectorBoxes) {
                 aabb1 = block1.getSelectionAABB(this, blockStart);
             } else {
                 aabb1 = block1.getCollisionAABB(this, blockStart);
             }
-            int metadata1 = getBlockData(blockStart);
+            final int metadata1 = this.getBlockData(blockStart);
             if ((!ignoreNonColliderBlocks || aabb1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids)) {
-                HitResult hitResult = block1.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
+                final HitResult hitResult = block1.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
                 if (hitResult != null) {
                     return hitResult;
                 }
@@ -1092,32 +1054,32 @@ public class World implements MutableWorldSource {
         return null;
     }
 
-    public void playSoundAtEntity(@Nullable Entity player, @NotNull Entity entity, String soundPath, float volume, float pitch) {
-        for (LevelListener listener : this.listeners) {
+    public void playSoundAtEntity(@Nullable final Entity player, @NotNull final Entity entity, final String soundPath, final float volume, final float pitch) {
+        for (final LevelListener listener : this.listeners) {
             listener.playSound(player, soundPath, SoundCategory.ENTITY_SOUNDS, entity.x, entity.y - (double) entity.heightOffset, entity.z, volume, pitch);
         }
 
     }
 
-    public void playSoundEffect(@Nullable Entity player, SoundCategory category, double x, double y, double z, String soundPath,
-                                float volume, float pitch) {
-        for (LevelListener listener : this.listeners) {
+    public void playSoundEffect(@Nullable final Entity player, final SoundCategory category, final double x, final double y, final double z, final String soundPath,
+                                final float volume, final float pitch) {
+        for (final LevelListener listener : this.listeners) {
             listener.playSound(player, soundPath, category, x, y, z, volume, pitch);
         }
     }
 
-    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, final @NotNull Block<?> block, EnumBlockSoundEffectType soundType) {
-        BlockSound sound = block.getSound();
+    public void playBlockSoundEffect(@Nullable final Entity player, final double x, final double y, final double z, final @NotNull Block<?> block, final EnumBlockSoundEffectType soundType) {
+        final BlockSound sound = block.getSound();
         if (sound == null) return;
 
-        String name;
+        final String name;
         if (soundType == EnumBlockSoundEffectType.MINE) {
             name = sound.getBreakSoundName();
         } else {
             name = sound.getStepSoundName();
         }
 
-        playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x, y, z, name, soundType.modifyVolume(sound.getVolume()), soundType.modifyPitch(sound.getPitch()));
+        this.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x, y, z, name, soundType.modifyVolume(sound.getVolume()), soundType.modifyPitch(sound.getPitch()));
     }
 
     public void playRecord(final @Nullable String soundPath, final @Nullable String author, final @NotNull TilePos tilePos) {
@@ -1163,40 +1125,40 @@ public class World implements MutableWorldSource {
         this.rainbowTicks = this.startingRainbowTicks = rainbowTicks;
     }
 
-    public boolean entityJoinedWorld(Entity entity) {
-        int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
-        int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
-        boolean flag = entity instanceof Player;
-        if (flag || isChunkLoaded(i, j)) {
-            if (entity instanceof Player entityplayer) {
+    public boolean entityJoinedWorld(final Entity entity) {
+        final int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
+        final int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
+        final boolean flag = entity instanceof Player;
+        if (flag || this.isChunkLoaded(i, j)) {
+            if (entity instanceof final Player entityplayer) {
                 this.players.add(entityplayer);
-                updateEnoughPlayersSleepingFlag(null);
+                this.updateEnoughPlayersSleepingFlag(null);
             }
 
-            getChunkFromChunkCoords(i, j).addEntity(entity);
+            this.getChunkFromChunkCoords(i, j).addEntity(entity);
             this.entities.add(entity);
-            obtainEntitySkin(entity);
+            this.obtainEntitySkin(entity);
             return true;
         } else {
             return false;
         }
     }
 
-    protected void obtainEntitySkin(Entity entity) {
+    protected void obtainEntitySkin(final Entity entity) {
         for (int i = 0; i < this.listeners.size(); i++) {
             this.listeners.get(i).entityAdded(entity);
         }
 
     }
 
-    protected void releaseEntitySkin(Entity entity) {
+    protected void releaseEntitySkin(final Entity entity) {
         for (int i = 0; i < this.listeners.size(); i++) {
             this.listeners.get(i).entityRemoved(entity);
         }
 
     }
 
-    public void setEntityDead(Entity entity) {
+    public void setEntityDead(final Entity entity) {
         if (entity.passenger != null) {
             entity.passenger.startRiding(null);
         }
